/*--
Copyright (c) 2003  Alexander A. Telyatnikov

Module Name:

    ora_common.h

Abstract:

    Some definitions for Console SQL client to Oracle

Environment:

    Win32.

Notes:


--*/
#ifndef __ORA_COMMON_H__
#define __ORA_COMMON_H__

#include <stdio.h>
#include <ctype.h>
#include <string.h>


/* Include OCI-specific headers. */
#include <oratypes.h>
#include <ocidfn.h>
#ifdef __STDC__
#include <ociapr.h>
#else
#include <ocikpr.h>
#endif
#include <ocidem.h>


/* Constants used in this program. */
#define MAX_BINDS               12
#define MAX_ITEM_BUFFER_SIZE    33
#define MAX_SELECT_LIST_SIZE    12
#define MAX_SQL_IDENTIFIER      31

#define PARSE_NO_DEFER          0
#define PARSE_V7_LNG            2

#define OCI_TYPECODE_DOUBLE     22

/* Declare structures for query information. */
struct describe
{
    sb4             dbsize;
    sb2             dbtype;
    sb1             buf[MAX_ITEM_BUFFER_SIZE];
    sb4             buflen;
    sb4             dsize;
    sb2             precision;
    sb2             scale;
    sb2             nullok;
};

struct define
{
    ub1             buf[MAX_ITEM_BUFFER_SIZE];
    __int64         int64_buf;
    float           flt_buf;
    sword           int_buf;
    sb2             indp;
    ub2             col_retlen, col_retcode;
};

typedef struct _ora_link {
    Lda_Def lda;
    Cda_Def cda;
    ub4     hda[HDA_SIZE/(sizeof(ub4))];

    struct describe desc[MAX_SELECT_LIST_SIZE];
    struct define   def[MAX_SELECT_LIST_SIZE];
} ora_link;

typedef struct _ora_result {
    ora_link* link;
    int       ncols;
} ora_result;

#endif //__ORA_COMMON_H__
